unit uGUI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  uSpielmanager;

type
  TGUI = class(TForm)
    PTitel: TPanel;
    GBWuerfel: TGroupBox;
    GBKonto: TGroupBox;
    PWuerfelA: TPanel;
    PWuerfelB: TPanel;
    PWuerfelC: TPanel;
    PKonto: TPanel;
    RGSpielbrett: TRadioGroup;
    BGewinnVerbuchen: TButton;
    BWuerfelWerfen: TButton;
    BEinsatzZahlen: TButton;
    procedure FormCreate(Sender: TObject);
    procedure RGSpielbrettClick(Sender: TObject);
    procedure BGewinnVerbuchenClick(Sender: TObject);
    procedure BWuerfelWerfenClick(Sender: TObject);
    procedure BEinsatzZahlenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
    spielmanager: TSpielmanager;
    procedure spielDatenAnzeigen;
  public
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;


implementation

{$R *.DFM}

procedure TGUI.spielDatenAnzeigen;
begin
  PWuerfelA.Caption  := IntToStr(spielmanager.getWertA);
  PWuerfelB.Caption  := IntToStr(spielmanager.getWertB);
  PWuerfelC.Caption  := IntToStr(spielmanager.getWertC);
  PKonto.Caption := IntToStr(spielmanager.getKonto);
end;

procedure TGUI.FormCreate(Sender: TObject);
begin
  randomize;
  spielmanager := TSpielmanager.create;
  spielDatenAnzeigen;
  RGSpielbrett.Enabled := false;
end;

procedure TGUI.RGSpielbrettClick(Sender: TObject);
  var tipp: integer;
begin
  tipp := RGSpielbrett.ItemIndex+1;
  spielmanager.spielzahlSetzen(tipp);
end;

procedure TGUI.BGewinnVerbuchenClick(Sender: TObject);
begin
  // Aktualisierung der Modell-Objekte
  spielmanager.gewinnVerbuchen;
  // Aktualisierung der Anzeige
  spielDatenAnzeigen;
end;

procedure TGUI.BWuerfelWerfenClick(Sender: TObject);
begin
  // Aktualisierung der Modell-Objekte
  spielmanager.wuerfelWerfen;
  // Aktualisierung der Anzeige
  spielDatenAnzeigen;
  RGSpielbrett.Enabled := false;
end;

procedure TGUI.BEinsatzZahlenClick(Sender: TObject);
begin
  // Aktualisierung des Modells
  spielmanager.einsatzZahlen;
  // Aktualisierung der Anzeige
  spielDatenAnzeigen;
  if spielmanager.getZUstand = 1 then RGSpielbrett.Enabled := true;
end;

procedure TGUI.FormDestroy(Sender: TObject);
begin
  spielmanager.free;
end;

end.
