unit uGUI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  uWuerfel, uIdealerWuerfel, uGezinkterWuerfel, uSpielbrett, uKonto, uSpielmanager;

type
  TGUI = class(TForm)
    PTitel: TPanel;
    GBWuerfel: TGroupBox;
    GBKonto: TGroupBox;
    PWuerfelA: TPanel;
    PWuerfelB: TPanel;
    PWuerfelC: TPanel;
    PKonto: TPanel;
    RGSpielbrett: TRadioGroup;
    BGewinnVerbuchen: TButton;
    BWuerfelWerfen: TButton;
    BEinsatzZahlen: TButton;
    procedure FormCreate(Sender: TObject);
    procedure RGSpielbrettClick(Sender: TObject);
    procedure BGewinnVerbuchenClick(Sender: TObject);
    procedure BWuerfelWerfenClick(Sender: TObject);
    procedure BEinsatzZahlenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
    wuerfelA, wuerfelB, wuerfelC: TWuerfel;
    spielbrett: TSpielbrett;
    konto: TKonto;
    spielmanager: TSpielmanager;
    procedure spielDatenAnzeigen;
  public
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;


implementation

{$R *.DFM}

procedure TGUI.spielDatenAnzeigen;
begin
  PWuerfelA.Caption  := IntToStr(wuerfelA.getAugen);
  PWuerfelB.Caption  := IntToStr(wuerfelB.getAugen);
  PWuerfelC.Caption  := IntToStr(wuerfelC.getAugen);
  PKonto.Caption := IntToStr(konto.getStand);
end;

procedure TGUI.FormCreate(Sender: TObject);
  var hilf: integer;
begin
  randomize;
  hilf := random(2);
  if hilf = 0 then
  begin
    wuerfelA := TIdealerWuerfel.create;
    wuerfelB := TIdealerWuerfel.create;
    wuerfelC := TIdealerWuerfel.create;
  end
  else
  begin
    wuerfelA := TGezinkterWuerfel.create;
    wuerfelB := TGezinkterWuerfel.create;
    wuerfelC := TGezinkterWuerfel.create;
  end;
  spielbrett := TSpielbrett.create;
  konto := TKonto.create(100);
  spielmanager := TSpielmanager.create
                  (spielbrett, wuerfelA, wuerfelB, wuerfelC, konto);
  spielDatenAnzeigen;
  RGSpielbrett.Enabled := false;
end;

procedure TGUI.RGSpielbrettClick(Sender: TObject);
  var tipp: integer;
begin
  tipp := RGSpielbrett.ItemIndex+1;
  spielmanager.spielzahlSetzen(tipp);
end;

procedure TGUI.BGewinnVerbuchenClick(Sender: TObject);
begin
  // Aktualisierung der Modell-Objekte
  spielmanager.gewinnVerbuchen;
  // Aktualisierung der Anzeige
  spielDatenAnzeigen;
end;

procedure TGUI.BWuerfelWerfenClick(Sender: TObject);
begin
  // Aktualisierung der Modell-Objekte
  spielmanager.wuerfelWerfen;
  // Aktualisierung der Anzeige
  spielDatenAnzeigen;
  RGSpielbrett.Enabled := false;
end;

procedure TGUI.BEinsatzZahlenClick(Sender: TObject);
begin
  // Aktualisierung des Modells
  spielmanager.einsatzZahlen;
  // Aktualisierung der Anzeige
  spielDatenAnzeigen;
  if spielmanager.getZustand = 1 then RGSpielbrett.Enabled := true;
end;

procedure TGUI.FormDestroy(Sender: TObject);
begin
  spielbrett.free;
  konto.free;
  wuerfelC.free;
  wuerfelB.free;
  wuerfelA.free;
  spielmanager.free;
end;

end.
